# coding: utf-8

"""
    DocuSign Click API

    Elastic signing (also known as DocuSign Click)  lets you capture consent to standard agreement terms with a single click: terms and conditions, terms of service, terms of use, privacy policies, and more. The Click API lets you include this customizable elastic template solution in your DocuSign integrations.  # noqa: E501

    OpenAPI spec version: v1
    Contact: devcenter@docusign.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from docusign_click.client.configuration import Configuration


class ClickwrapVersionsPagedResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'account_id': 'str',
        'clickwrap_id': 'str',
        'clickwrap_name': 'str',
        'minimum_pages_remaining': 'int',
        'page': 'int',
        'page_size': 'int',
        'versions': 'list[ClickwrapVersion]'
    }

    attribute_map = {
        'account_id': 'accountId',
        'clickwrap_id': 'clickwrapId',
        'clickwrap_name': 'clickwrapName',
        'minimum_pages_remaining': 'minimumPagesRemaining',
        'page': 'page',
        'page_size': 'pageSize',
        'versions': 'versions'
    }

    def __init__(self, _configuration=None, **kwargs):  # noqa: E501
        """ClickwrapVersionsPagedResponse - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._account_id = None
        self._clickwrap_id = None
        self._clickwrap_name = None
        self._minimum_pages_remaining = None
        self._page = None
        self._page_size = None
        self._versions = None
        self.discriminator = None

        setattr(self, "_{}".format('account_id'), kwargs.get('account_id', None))
        setattr(self, "_{}".format('clickwrap_id'), kwargs.get('clickwrap_id', None))
        setattr(self, "_{}".format('clickwrap_name'), kwargs.get('clickwrap_name', None))
        setattr(self, "_{}".format('minimum_pages_remaining'), kwargs.get('minimum_pages_remaining', None))
        setattr(self, "_{}".format('page'), kwargs.get('page', None))
        setattr(self, "_{}".format('page_size'), kwargs.get('page_size', None))
        setattr(self, "_{}".format('versions'), kwargs.get('versions', None))

    @property
    def account_id(self):
        """Gets the account_id of this ClickwrapVersionsPagedResponse.  # noqa: E501

        The external account number (int) or account ID GUID.  # noqa: E501

        :return: The account_id of this ClickwrapVersionsPagedResponse.  # noqa: E501
        :rtype: str
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this ClickwrapVersionsPagedResponse.

        The external account number (int) or account ID GUID.  # noqa: E501

        :param account_id: The account_id of this ClickwrapVersionsPagedResponse.  # noqa: E501
        :type: str
        """

        self._account_id = account_id

    @property
    def clickwrap_id(self):
        """Gets the clickwrap_id of this ClickwrapVersionsPagedResponse.  # noqa: E501

        The ID of the clickwrap.  # noqa: E501

        :return: The clickwrap_id of this ClickwrapVersionsPagedResponse.  # noqa: E501
        :rtype: str
        """
        return self._clickwrap_id

    @clickwrap_id.setter
    def clickwrap_id(self, clickwrap_id):
        """Sets the clickwrap_id of this ClickwrapVersionsPagedResponse.

        The ID of the clickwrap.  # noqa: E501

        :param clickwrap_id: The clickwrap_id of this ClickwrapVersionsPagedResponse.  # noqa: E501
        :type: str
        """

        self._clickwrap_id = clickwrap_id

    @property
    def clickwrap_name(self):
        """Gets the clickwrap_name of this ClickwrapVersionsPagedResponse.  # noqa: E501

        The name of the clickwrap.  # noqa: E501

        :return: The clickwrap_name of this ClickwrapVersionsPagedResponse.  # noqa: E501
        :rtype: str
        """
        return self._clickwrap_name

    @clickwrap_name.setter
    def clickwrap_name(self, clickwrap_name):
        """Sets the clickwrap_name of this ClickwrapVersionsPagedResponse.

        The name of the clickwrap.  # noqa: E501

        :param clickwrap_name: The clickwrap_name of this ClickwrapVersionsPagedResponse.  # noqa: E501
        :type: str
        """

        self._clickwrap_name = clickwrap_name

    @property
    def minimum_pages_remaining(self):
        """Gets the minimum_pages_remaining of this ClickwrapVersionsPagedResponse.  # noqa: E501

        An array of clickwrap versions.  # noqa: E501

        :return: The minimum_pages_remaining of this ClickwrapVersionsPagedResponse.  # noqa: E501
        :rtype: int
        """
        return self._minimum_pages_remaining

    @minimum_pages_remaining.setter
    def minimum_pages_remaining(self, minimum_pages_remaining):
        """Sets the minimum_pages_remaining of this ClickwrapVersionsPagedResponse.

        An array of clickwrap versions.  # noqa: E501

        :param minimum_pages_remaining: The minimum_pages_remaining of this ClickwrapVersionsPagedResponse.  # noqa: E501
        :type: int
        """

        self._minimum_pages_remaining = minimum_pages_remaining

    @property
    def page(self):
        """Gets the page of this ClickwrapVersionsPagedResponse.  # noqa: E501

        The number of the current page.  # noqa: E501

        :return: The page of this ClickwrapVersionsPagedResponse.  # noqa: E501
        :rtype: int
        """
        return self._page

    @page.setter
    def page(self, page):
        """Sets the page of this ClickwrapVersionsPagedResponse.

        The number of the current page.  # noqa: E501

        :param page: The page of this ClickwrapVersionsPagedResponse.  # noqa: E501
        :type: int
        """

        self._page = page

    @property
    def page_size(self):
        """Gets the page_size of this ClickwrapVersionsPagedResponse.  # noqa: E501

        The number of items per page.  # noqa: E501

        :return: The page_size of this ClickwrapVersionsPagedResponse.  # noqa: E501
        :rtype: int
        """
        return self._page_size

    @page_size.setter
    def page_size(self, page_size):
        """Sets the page_size of this ClickwrapVersionsPagedResponse.

        The number of items per page.  # noqa: E501

        :param page_size: The page_size of this ClickwrapVersionsPagedResponse.  # noqa: E501
        :type: int
        """

        self._page_size = page_size

    @property
    def versions(self):
        """Gets the versions of this ClickwrapVersionsPagedResponse.  # noqa: E501

        An array of clickwrap versions.  # noqa: E501

        :return: The versions of this ClickwrapVersionsPagedResponse.  # noqa: E501
        :rtype: list[ClickwrapVersion]
        """
        return self._versions

    @versions.setter
    def versions(self, versions):
        """Sets the versions of this ClickwrapVersionsPagedResponse.

        An array of clickwrap versions.  # noqa: E501

        :param versions: The versions of this ClickwrapVersionsPagedResponse.  # noqa: E501
        :type: list[ClickwrapVersion]
        """

        self._versions = versions

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ClickwrapVersionsPagedResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ClickwrapVersionsPagedResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ClickwrapVersionsPagedResponse):
            return True

        return self.to_dict() != other.to_dict()
