# coding: utf-8

"""
    DocuSign Click API

    Elastic signing (also known as DocuSign Click)  lets you capture consent to standard agreement terms with a single click: terms and conditions, terms of service, terms of use, privacy policies, and more. The Click API lets you include this customizable elastic template solution in your DocuSign integrations.  # noqa: E501

    OpenAPI spec version: v1
    Contact: devcenter@docusign.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from docusign_click.client.configuration import Configuration


class UserAgreementResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'account_id': 'str',
        'agreed_on': 'object',
        'agreement_id': 'str',
        'agreement_url': 'str',
        'clickwrap_id': 'str',
        'client_user_id': 'str',
        'consumer_disclosure_enabled': 'bool',
        'consumer_disclosure_html': 'str',
        'created_on': 'object',
        'data_fields': 'list[DataField]',
        'declined_on': 'object',
        'document_data': 'dict(str, str)',
        'documents': 'list[Document]',
        'metadata': 'str',
        'return_url': 'str',
        'settings': 'DisplaySettings',
        'status': 'str',
        'style': 'UserAgreementResponseStyle',
        'version': 'str',
        'version_id': 'str',
        'version_number': 'int'
    }

    attribute_map = {
        'account_id': 'accountId',
        'agreed_on': 'agreedOn',
        'agreement_id': 'agreementId',
        'agreement_url': 'agreementUrl',
        'clickwrap_id': 'clickwrapId',
        'client_user_id': 'clientUserId',
        'consumer_disclosure_enabled': 'consumerDisclosureEnabled',
        'consumer_disclosure_html': 'consumerDisclosureHtml',
        'created_on': 'createdOn',
        'data_fields': 'dataFields',
        'declined_on': 'declinedOn',
        'document_data': 'documentData',
        'documents': 'documents',
        'metadata': 'metadata',
        'return_url': 'returnUrl',
        'settings': 'settings',
        'status': 'status',
        'style': 'style',
        'version': 'version',
        'version_id': 'versionId',
        'version_number': 'versionNumber'
    }

    def __init__(self, _configuration=None, **kwargs):  # noqa: E501
        """UserAgreementResponse - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._account_id = None
        self._agreed_on = None
        self._agreement_id = None
        self._agreement_url = None
        self._clickwrap_id = None
        self._client_user_id = None
        self._consumer_disclosure_enabled = None
        self._consumer_disclosure_html = None
        self._created_on = None
        self._data_fields = None
        self._declined_on = None
        self._document_data = None
        self._documents = None
        self._metadata = None
        self._return_url = None
        self._settings = None
        self._status = None
        self._style = None
        self._version = None
        self._version_id = None
        self._version_number = None
        self.discriminator = None

        setattr(self, "_{}".format('account_id'), kwargs.get('account_id', None))
        setattr(self, "_{}".format('agreed_on'), kwargs.get('agreed_on', None))
        setattr(self, "_{}".format('agreement_id'), kwargs.get('agreement_id', None))
        setattr(self, "_{}".format('agreement_url'), kwargs.get('agreement_url', None))
        setattr(self, "_{}".format('clickwrap_id'), kwargs.get('clickwrap_id', None))
        setattr(self, "_{}".format('client_user_id'), kwargs.get('client_user_id', None))
        setattr(self, "_{}".format('consumer_disclosure_enabled'), kwargs.get('consumer_disclosure_enabled', None))
        setattr(self, "_{}".format('consumer_disclosure_html'), kwargs.get('consumer_disclosure_html', None))
        setattr(self, "_{}".format('created_on'), kwargs.get('created_on', None))
        setattr(self, "_{}".format('data_fields'), kwargs.get('data_fields', None))
        setattr(self, "_{}".format('declined_on'), kwargs.get('declined_on', None))
        setattr(self, "_{}".format('document_data'), kwargs.get('document_data', None))
        setattr(self, "_{}".format('documents'), kwargs.get('documents', None))
        setattr(self, "_{}".format('metadata'), kwargs.get('metadata', None))
        setattr(self, "_{}".format('return_url'), kwargs.get('return_url', None))
        setattr(self, "_{}".format('settings'), kwargs.get('settings', None))
        setattr(self, "_{}".format('status'), kwargs.get('status', None))
        setattr(self, "_{}".format('style'), kwargs.get('style', None))
        setattr(self, "_{}".format('version'), kwargs.get('version', None))
        setattr(self, "_{}".format('version_id'), kwargs.get('version_id', None))
        setattr(self, "_{}".format('version_number'), kwargs.get('version_number', None))

    @property
    def account_id(self):
        """Gets the account_id of this UserAgreementResponse.  # noqa: E501

        The external account number (int) or account ID GUID.  # noqa: E501

        :return: The account_id of this UserAgreementResponse.  # noqa: E501
        :rtype: str
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this UserAgreementResponse.

        The external account number (int) or account ID GUID.  # noqa: E501

        :param account_id: The account_id of this UserAgreementResponse.  # noqa: E501
        :type: str
        """

        self._account_id = account_id

    @property
    def agreed_on(self):
        """Gets the agreed_on of this UserAgreementResponse.  # noqa: E501

        Date that the client last completed the agreement.  This property is null if `agreementUrl` is not null and `status` is not  `agreed`.  # noqa: E501

        :return: The agreed_on of this UserAgreementResponse.  # noqa: E501
        :rtype: object
        """
        return self._agreed_on

    @agreed_on.setter
    def agreed_on(self, agreed_on):
        """Sets the agreed_on of this UserAgreementResponse.

        Date that the client last completed the agreement.  This property is null if `agreementUrl` is not null and `status` is not  `agreed`.  # noqa: E501

        :param agreed_on: The agreed_on of this UserAgreementResponse.  # noqa: E501
        :type: object
        """

        self._agreed_on = agreed_on

    @property
    def agreement_id(self):
        """Gets the agreement_id of this UserAgreementResponse.  # noqa: E501

        The agreement ID.  # noqa: E501

        :return: The agreement_id of this UserAgreementResponse.  # noqa: E501
        :rtype: str
        """
        return self._agreement_id

    @agreement_id.setter
    def agreement_id(self, agreement_id):
        """Sets the agreement_id of this UserAgreementResponse.

        The agreement ID.  # noqa: E501

        :param agreement_id: The agreement_id of this UserAgreementResponse.  # noqa: E501
        :type: str
        """

        self._agreement_id = agreement_id

    @property
    def agreement_url(self):
        """Gets the agreement_url of this UserAgreementResponse.  # noqa: E501

        When not null, an agreement is required for user specified by  `clientUserId`.  When missing the user specified by `clientUserId` has already agreed and does not require a new acceptance.  Use this URL to render the agreement in a web page.  <!-- or redirected to when providing redirect_url as a query parameter. -->   # noqa: E501

        :return: The agreement_url of this UserAgreementResponse.  # noqa: E501
        :rtype: str
        """
        return self._agreement_url

    @agreement_url.setter
    def agreement_url(self, agreement_url):
        """Sets the agreement_url of this UserAgreementResponse.

        When not null, an agreement is required for user specified by  `clientUserId`.  When missing the user specified by `clientUserId` has already agreed and does not require a new acceptance.  Use this URL to render the agreement in a web page.  <!-- or redirected to when providing redirect_url as a query parameter. -->   # noqa: E501

        :param agreement_url: The agreement_url of this UserAgreementResponse.  # noqa: E501
        :type: str
        """

        self._agreement_url = agreement_url

    @property
    def clickwrap_id(self):
        """Gets the clickwrap_id of this UserAgreementResponse.  # noqa: E501

        The ID of the clickwrap.  # noqa: E501

        :return: The clickwrap_id of this UserAgreementResponse.  # noqa: E501
        :rtype: str
        """
        return self._clickwrap_id

    @clickwrap_id.setter
    def clickwrap_id(self, clickwrap_id):
        """Sets the clickwrap_id of this UserAgreementResponse.

        The ID of the clickwrap.  # noqa: E501

        :param clickwrap_id: The clickwrap_id of this UserAgreementResponse.  # noqa: E501
        :type: str
        """

        self._clickwrap_id = clickwrap_id

    @property
    def client_user_id(self):
        """Gets the client_user_id of this UserAgreementResponse.  # noqa: E501

        A unique value that identifies a user.\\nYou can use anything that your system uses\\nto identify unique users, such as\\nemployee IDs, email addresses, and surrogate keys as the value of `clientUserId`.\\n\\nA clickwrap with a specific `clientUserId` will not appear again\\nonce it has been accepted.\\n\"  # noqa: E501

        :return: The client_user_id of this UserAgreementResponse.  # noqa: E501
        :rtype: str
        """
        return self._client_user_id

    @client_user_id.setter
    def client_user_id(self, client_user_id):
        """Sets the client_user_id of this UserAgreementResponse.

        A unique value that identifies a user.\\nYou can use anything that your system uses\\nto identify unique users, such as\\nemployee IDs, email addresses, and surrogate keys as the value of `clientUserId`.\\n\\nA clickwrap with a specific `clientUserId` will not appear again\\nonce it has been accepted.\\n\"  # noqa: E501

        :param client_user_id: The client_user_id of this UserAgreementResponse.  # noqa: E501
        :type: str
        """

        self._client_user_id = client_user_id

    @property
    def consumer_disclosure_enabled(self):
        """Gets the consumer_disclosure_enabled of this UserAgreementResponse.  # noqa: E501

        **True** if consumer disclosure was required by this agreement.  # noqa: E501

        :return: The consumer_disclosure_enabled of this UserAgreementResponse.  # noqa: E501
        :rtype: bool
        """
        return self._consumer_disclosure_enabled

    @consumer_disclosure_enabled.setter
    def consumer_disclosure_enabled(self, consumer_disclosure_enabled):
        """Sets the consumer_disclosure_enabled of this UserAgreementResponse.

        **True** if consumer disclosure was required by this agreement.  # noqa: E501

        :param consumer_disclosure_enabled: The consumer_disclosure_enabled of this UserAgreementResponse.  # noqa: E501
        :type: bool
        """

        self._consumer_disclosure_enabled = consumer_disclosure_enabled

    @property
    def consumer_disclosure_html(self):
        """Gets the consumer_disclosure_html of this UserAgreementResponse.  # noqa: E501

        The customer-branded HTML with the Electronic Record and Signature Disclosure information  # noqa: E501

        :return: The consumer_disclosure_html of this UserAgreementResponse.  # noqa: E501
        :rtype: str
        """
        return self._consumer_disclosure_html

    @consumer_disclosure_html.setter
    def consumer_disclosure_html(self, consumer_disclosure_html):
        """Sets the consumer_disclosure_html of this UserAgreementResponse.

        The customer-branded HTML with the Electronic Record and Signature Disclosure information  # noqa: E501

        :param consumer_disclosure_html: The consumer_disclosure_html of this UserAgreementResponse.  # noqa: E501
        :type: str
        """

        self._consumer_disclosure_html = consumer_disclosure_html

    @property
    def created_on(self):
        """Gets the created_on of this UserAgreementResponse.  # noqa: E501

        The date when the clickwrap was created. May be null.  # noqa: E501

        :return: The created_on of this UserAgreementResponse.  # noqa: E501
        :rtype: object
        """
        return self._created_on

    @created_on.setter
    def created_on(self, created_on):
        """Sets the created_on of this UserAgreementResponse.

        The date when the clickwrap was created. May be null.  # noqa: E501

        :param created_on: The created_on of this UserAgreementResponse.  # noqa: E501
        :type: object
        """

        self._created_on = created_on

    @property
    def data_fields(self):
        """Gets the data_fields of this UserAgreementResponse.  # noqa: E501

        The list of all the data fields available for the clickwrap (custom fields and standard fields).  # noqa: E501

        :return: The data_fields of this UserAgreementResponse.  # noqa: E501
        :rtype: list[DataField]
        """
        return self._data_fields

    @data_fields.setter
    def data_fields(self, data_fields):
        """Sets the data_fields of this UserAgreementResponse.

        The list of all the data fields available for the clickwrap (custom fields and standard fields).  # noqa: E501

        :param data_fields: The data_fields of this UserAgreementResponse.  # noqa: E501
        :type: list[DataField]
        """

        self._data_fields = data_fields

    @property
    def declined_on(self):
        """Gets the declined_on of this UserAgreementResponse.  # noqa: E501

        The date when the user declined the most recent required agreement.  This property is valid only when `status` is `declined`. Otherwise it is null.  # noqa: E501

        :return: The declined_on of this UserAgreementResponse.  # noqa: E501
        :rtype: object
        """
        return self._declined_on

    @declined_on.setter
    def declined_on(self, declined_on):
        """Sets the declined_on of this UserAgreementResponse.

        The date when the user declined the most recent required agreement.  This property is valid only when `status` is `declined`. Otherwise it is null.  # noqa: E501

        :param declined_on: The declined_on of this UserAgreementResponse.  # noqa: E501
        :type: object
        """

        self._declined_on = declined_on

    @property
    def document_data(self):
        """Gets the document_data of this UserAgreementResponse.  # noqa: E501

        This property specifies the data used to create a clickwrap with [dynamic content][].    [dynamic content]: /docs/click-api/click101/customize-clickwrap-fields/#embed-clickwraps-that-contain-dynamic-content   # noqa: E501

        :return: The document_data of this UserAgreementResponse.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._document_data

    @document_data.setter
    def document_data(self, document_data):
        """Sets the document_data of this UserAgreementResponse.

        This property specifies the data used to create a clickwrap with [dynamic content][].    [dynamic content]: /docs/click-api/click101/customize-clickwrap-fields/#embed-clickwraps-that-contain-dynamic-content   # noqa: E501

        :param document_data: The document_data of this UserAgreementResponse.  # noqa: E501
        :type: dict(str, str)
        """

        self._document_data = document_data

    @property
    def documents(self):
        """Gets the documents of this UserAgreementResponse.  # noqa: E501

        An array of documents.  # noqa: E501

        :return: The documents of this UserAgreementResponse.  # noqa: E501
        :rtype: list[Document]
        """
        return self._documents

    @documents.setter
    def documents(self, documents):
        """Sets the documents of this UserAgreementResponse.

        An array of documents.  # noqa: E501

        :param documents: The documents of this UserAgreementResponse.  # noqa: E501
        :type: list[Document]
        """

        self._documents = documents

    @property
    def metadata(self):
        """Gets the metadata of this UserAgreementResponse.  # noqa: E501

        A customer-defined string you can use in requests. This string will appear in the corresponding response.  # noqa: E501

        :return: The metadata of this UserAgreementResponse.  # noqa: E501
        :rtype: str
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this UserAgreementResponse.

        A customer-defined string you can use in requests. This string will appear in the corresponding response.  # noqa: E501

        :param metadata: The metadata of this UserAgreementResponse.  # noqa: E501
        :type: str
        """

        self._metadata = metadata

    @property
    def return_url(self):
        """Gets the return_url of this UserAgreementResponse.  # noqa: E501

        The URL redirected to after the agreement was completed.  # noqa: E501

        :return: The return_url of this UserAgreementResponse.  # noqa: E501
        :rtype: str
        """
        return self._return_url

    @return_url.setter
    def return_url(self, return_url):
        """Sets the return_url of this UserAgreementResponse.

        The URL redirected to after the agreement was completed.  # noqa: E501

        :param return_url: The return_url of this UserAgreementResponse.  # noqa: E501
        :type: str
        """

        self._return_url = return_url

    @property
    def settings(self):
        """Gets the settings of this UserAgreementResponse.  # noqa: E501

        The display settings for this agreement.  # noqa: E501

        :return: The settings of this UserAgreementResponse.  # noqa: E501
        :rtype: DisplaySettings
        """
        return self._settings

    @settings.setter
    def settings(self, settings):
        """Sets the settings of this UserAgreementResponse.

        The display settings for this agreement.  # noqa: E501

        :param settings: The settings of this UserAgreementResponse.  # noqa: E501
        :type: DisplaySettings
        """

        self._settings = settings

    @property
    def status(self):
        """Gets the status of this UserAgreementResponse.  # noqa: E501

        User agreement status. One of:  - `created` - `agreed` - `declined`  # noqa: E501

        :return: The status of this UserAgreementResponse.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this UserAgreementResponse.

        User agreement status. One of:  - `created` - `agreed` - `declined`  # noqa: E501

        :param status: The status of this UserAgreementResponse.  # noqa: E501
        :type: str
        """

        self._status = status

    @property
    def style(self):
        """Gets the style of this UserAgreementResponse.  # noqa: E501


        :return: The style of this UserAgreementResponse.  # noqa: E501
        :rtype: UserAgreementResponseStyle
        """
        return self._style

    @style.setter
    def style(self, style):
        """Sets the style of this UserAgreementResponse.


        :param style: The style of this UserAgreementResponse.  # noqa: E501
        :type: UserAgreementResponseStyle
        """

        self._style = style

    @property
    def version(self):
        """Gets the version of this UserAgreementResponse.  # noqa: E501

        The human-readable semver version string.  # noqa: E501

        :return: The version of this UserAgreementResponse.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this UserAgreementResponse.

        The human-readable semver version string.  # noqa: E501

        :param version: The version of this UserAgreementResponse.  # noqa: E501
        :type: str
        """

        self._version = version

    @property
    def version_id(self):
        """Gets the version_id of this UserAgreementResponse.  # noqa: E501

        The ID of the version.  # noqa: E501

        :return: The version_id of this UserAgreementResponse.  # noqa: E501
        :rtype: str
        """
        return self._version_id

    @version_id.setter
    def version_id(self, version_id):
        """Sets the version_id of this UserAgreementResponse.

        The ID of the version.  # noqa: E501

        :param version_id: The version_id of this UserAgreementResponse.  # noqa: E501
        :type: str
        """

        self._version_id = version_id

    @property
    def version_number(self):
        """Gets the version_number of this UserAgreementResponse.  # noqa: E501

        Version of the clickwrap.  # noqa: E501

        :return: The version_number of this UserAgreementResponse.  # noqa: E501
        :rtype: int
        """
        return self._version_number

    @version_number.setter
    def version_number(self, version_number):
        """Sets the version_number of this UserAgreementResponse.

        Version of the clickwrap.  # noqa: E501

        :param version_number: The version_number of this UserAgreementResponse.  # noqa: E501
        :type: int
        """

        self._version_number = version_number

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UserAgreementResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UserAgreementResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, UserAgreementResponse):
            return True

        return self.to_dict() != other.to_dict()
